AppTitle "BREAKOUT: Remix"

Graphics 800,600,0,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()

menu_song=PlayMusic("Media\title_song.mod")

Global back=LoadImage("Media\back.jpg")

Global sh=LoadImage("Media\save_high.png")

Global saved=LoadImage("Media\hs_saved.png")

title=LoadImage("Media\title.png")

name=LoadImage("Media\name.png")
ScaleImage name,3,3

ResizeImage back,800,600

highg=ReadFile("high_score.dg")
hscore=ReadInt(highg)
high_score_pic=LoadImage("Media\high_score.png")

Global record_high=hscore

temp_font=LoadFont("Cooper Black",24)
SetFont temp_font

Color 100,100,255

While Not KeyHit(57)
Cls
DrawBlock back,0,0
DrawImage title,200,400
DrawImage name,150,50
Text 400,00, hscore
DrawImage high_score_pic,200,00
Flip
Wend

fonty=LoadFont("Snap ITC",24)

fonty2=LoadFont("Snap ITC",29)

Dim map (7,7)

Restore level1
For y = 0 To 7 
	For x = 0 To 7 
		Read map ( x, y )
	Next
Next


Type block
	Field x#,y#
	Field image
	Field frame
End Type

Type p
	Field score
	Field x#,y#
	Field image
	Field lives
	Field level
	Field power
End Type

Type ball
	Field x#,y#
	Field xv#,yv#
	Field image
End Type

ClsColor 255,255,255



Global num=LoadAnimImage("Media\num.png",262/10,22,0,10)
Global lives=LoadImage("Media\lives.png")
Global score=LoadImage("Media\score.png")
Global level=LoadImage("Media\level.png")

Global powertimer=MilliSecs()

Global ball.ball=New ball
ball\x=300
ball\y=300
ball\xv=Rand(-3,3)
ball\yv=Rand(1,3)
ball\image=LoadImage("Media\ball.bmp")
ScaleImage ball\image,0.5,0.5
MaskImage ball\image,255,255,255

Global p.p=New p
p\x=400
p\y=550
p\lives=3
p\level=1
p\score=0
p\image=LoadAnimImage("Media\paddel.png",133,22,0,3)
MaskImage p\image,255,255,255

StopChannel menu_song

main_song=PlayMusic("Media\game_song.mod")

.nextlevel

If p\level>9 Then p\level=9

p\x=400
p\y=550

ball\x=300
ball\y=300
ball\xv=Rand(-3,3)
ball\yv=Rand(1,3)

bx=30
by=30
bbx=0
bby=0

Global blockcount=28

For blocknum=1 To 28
block.block=New block
For y=0 To 7
	For x=0 To 7
	If map(x,y)=1 Then block\x=x*100:block\y=y*30
	Next
Next
block\image=LoadAnimImage("Media\blocks.bmp",100,35,0,6)
block\frame=Rand(0,5)
block\x=bx+bbx
block\y=by+bby
bbx=bbx+100
If bbx>600 Then bbx=0:bby=bby+53
MaskImage block\image,255,255,255
Next




Global mx=0
Global my=0

For block.block=Each block

Next

While Not KeyHit(1)
Cls

DrawBlock back,0,0

If KeyHit(2) Then SaveHigh()

ball\x=ball\x+ball\xv
ball\y=ball\y+ball\yv

If ImagesCollide(p\image,p\x,p\y,0,ball\image,ball\x,ball\y,0) Then ball\xv=Rand(-3,3):ball\yv=Rand(-2,-4)
If ball\x>775 Then ball\xv=Rand(-2,-4)
If ball\y<0 Then ball\yv=Rand(2,4)
If ball\x<0 Then ball\xv=Rand(2,4)
If ball\y>630 Then Die()

If KeyDown(205) Then p\x=p\x+5
If KeyDown(203) Then p\x=p\x-5

If p\x<0 Then p\x=0
If p\x>670 Then p\x=670

DrawImage p\image,p\x,p\y,0

DrawImage ball\image,ball\x,ball\y

For block.block=Each block
DrawImage block\image,block\x,block\y,block\frame
If ImagesCollide(block\image,block\x,block\y,block\frame,ball\image,ball\x,ball\y,0) 
If ball\y>block\y Then ball\yv=Rand(2,5)
If ball\y<block\y Then ball\yv=Rand(-2,-5)
Delete block
ball\xv=Rand(-4,4)
blockcount=blockcount-1
p\score=p\score+50
EndIf
Next

If blockcount<=0 Then Delay 2000:p\level=p\level+1:Goto nextlevel

DrawImage score,0,575
DrawImage lives,670,575
DrawImage level,300,0
DrawImage num,400,0,(p\level-1)
DrawImage num,770,575,(p\lives-1)

SetFont fonty2
Color 0,0,255
Text 97,573, p\score
SetFont fonty
Color 255,255,0
Text 100,575, p\score

Flip
Wend

Function Die()
p\lives=p\lives-1
ball\x=300
ball\y=300
ball\xv=Rand(-3,3)
ball\yv=Rand(1,3)
p\x=300
p\y=550
If p\lives<1 Then If p\score>record_high Then AskSaveHigh():End
End Function

If p\score>record_high Then AskSaveHigh()

End

Function AskSaveHigh()
While 5>1
Cls
DrawBlock back,0,0
DrawImage sh,300,200
If KeyHit(21) Then SaveHigh():DrawImage saved,300,400:Flip:Delay 2000:End
If KeyHit(49) Then End
Flip
Wend
End Function

Function SaveHigh()
high=WriteFile("high_score.dg")
;high=ReadFile("high_score.txt")
WriteInt(high,p\score)
End Function

;Coundn't get the levels working...

.level1
Data 1,1,1,1,1,1,1
Data 1,1,1,1,1,1,1
Data 1,1,1,1,1,1,1
Data 1,1,1,1,1,1,0
Data 0,0,0,0,0,0,0
Data 0,0,0,0,0,0,0
Data 0,0,0,0,0,0,1

.level2
Data 1,0,0,0,0,0,1
Data 1,0,1,0,1,0,1
Data 1,1,0,0,0,1,1
Data 1,1,0,0,0,1,1
Data 1,0,1,1,1,0,1
Data 1,0,0,0,0,0,1
Data 1,0,0,0,0,0,1